/***********************************************
 *
 * OG Script Dumper v2.51 by learn_more
 * File: out\a181\script\cam_dump.as
 * Generated: 04-Jun-2012 18:45:33
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3b4f60 (0x7b4f60)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xc0f00 (0x4c0f00)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xc0f30 (0x4c0f30)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b53e0 (0x7b53e0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3b5b20 (0x7b5b20)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b58b0 (0x7b58b0)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b57a0 (0x7b57a0)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b5b80 (0x7b5b80)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3b5670 (0x7b5670)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b5390 (0x7b5390)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b5b50 (0x7b5b50)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3b5410 (0x7b5410)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3b5540 (0x7b5540)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3b4fb0 (0x7b4fb0)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3b4a80 (0x7b4a80)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x24b600 (0x64b600)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x24a480 (0x64a480)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x24a4e0 (0x64a4e0)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x24b410 (0x64b410)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x24b480 (0x64b480)
	void Update();		// 'Overgrowth.exe' + 0x24f4e0 (0x64f4e0)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x2a9e60 (0x6a9e60)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2a9e10 (0x6a9e10)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x37bd50 (0x77bd50)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x37bbb0 (0x77bbb0)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0x37bb40 (0x77bb40)
	float GetLens();		// 'Overgrowth.exe' + 0x37bb90 (0x77bb90)
	void Update();		// 'Overgrowth.exe' + 0x37c1d0 (0x77c1d0)
	bool valid();		// 'Overgrowth.exe' + 0x37a110 (0x77a110)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x199e7030
SphereCollision sphere_col;		// 0x199e7034
GUI gui;		// 0x1c58eb18
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x4329e0 (0x8329e0)
CameraObject co;		// 0x1e728898
CameraAnimationReader camera_animation_reader;		// 0x1e728984
